//+------------------------------------------------------------------+
//|                                                   jbtrailall.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int TakeProfit=50;
extern int TrailingStop=5;
extern int StopLoss = 50;


// check open possitions and place sl, tp

string str;
int start()
{
   Comment(str);
   int cnt, totalOrders;
   totalOrders = OrdersTotal();

   if (totalOrders>0) // open orders identified
   {
      for (cnt=0;cnt<totalOrders;cnt++)
         {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         Print (" count ",cnt," by pos  ", SELECT_BY_POS," trades ", MODE_TRADES);

         if(OrderType()==OP_SELL && OrderSymbol()==Symbol())
            {
         Print ("order type  ", OrderType(),"  order symbol  ", OrderSymbol());   
            
            if (OrderStopLoss()==0)
               {
         Print (" order stop loss ", OrderStopLoss()); 
         
         // place SL and TP on SELL
         //-------------------     
               
  OrderModify(OrderTicket(),OrderOpenPrice(),Bid+StopLoss*Point,Bid-TakeProfit*Point,0,Red);
    
             }
    
     Print ("ticket  ",OrderTicket()," open price  ",OrderOpenPrice()," SL  ",OrderStopLoss() ==Ask+Point*StopLoss," TP  ",OrderTakeProfit()==Ask+Point*TakeProfit);        
      
   
              }           
               
       Print ("ticket  ",OrderTicket()," SL  ",OrderStopLoss() ==Ask+Point*StopLoss," TP  ",OrderTakeProfit()==Ask+Point*TakeProfit);        
        
         // place SL and TP on BUY
               //--------------------------
			   
			if(OrderType()==OP_BUY && OrderSymbol()==Symbol()) 
            { 
            if (OrderStopLoss()==0)
               {   
               
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask-StopLoss*Point,Ask+TakeProfit*Point,0,Green);
               }
                    
              }  
          // check trailing stop
       //----------------------------------------------------------------------     
                            
         if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           
         else // go to short position
           {
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
            }
         }
         }
      }
	 }
 }
 return(0);
} 